package name.panitz.wip.tree;
public interface Visitor<R>  {
  R visit(LetExpr lambda) throws Exception;
  R visit(CaseExpr lambda) throws Exception;
  R visit(MatchExpr lambda) throws Exception;
  R visit(ProjectionExpr lambda) throws Exception;
  R visit(LambdaExpr lambda) throws Exception;
  R visit(Var v) throws Exception;
  R visit(FunCall funcall) throws Exception;
  R visit(Program prog) throws Exception;
  R visit(FunDef fun) throws Exception;
  R visit(ConDef fun) throws Exception;
  R visit(IntLit il) throws Exception;
  R visit(StringLit il) throws Exception;
  R visit(MultExpr ex) throws Exception;
  R visit(DivExpr ex) throws Exception;
  R visit(ModExpr ex) throws Exception;
  R visit(AddExpr ex) throws Exception;
  R visit(SubExpr ex) throws Exception;
  R visit(EqExpr ex) throws Exception;
  R visit(NeqExpr ex) throws Exception;
  R visit(LeExpr ex) throws Exception;
  R visit(GeExpr ex) throws Exception;
  R visit(LtExpr ex) throws Exception;
  R visit(GtExpr ex) throws Exception;
  R visit(OrExpr ex) throws Exception;
  R visit(AndExpr ex) throws Exception;
  R visit(IfExpr ex) throws Exception;
  R visit(DataDef dataDef)throws Exception;
  R visit(VarDef varDef)throws Exception;
  R visit(BoolLit boolLit)throws Exception;
}

