package name.panitz.wip.types;

import java.util.List;
import java.util.Map;
import java.util.Set;
import java.util.stream.Collectors;

import name.panitz.wip.TypeDef;

public class ADT implements Type{
	String name;
	List<Type> args;
	public ADT(String name, List<Type> args) {
		super();
		this.name = name;
		this.args = args;
	}
	@Override
	public Type substitute(Substitution sub) {
		return new ADT(name
				, args.stream().map((x)-> x.substitute(sub)).collect(Collectors.toList()));
	}
	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((args == null) ? 0 : args.hashCode());
		result = prime * result + ((name == null) ? 0 : name.hashCode());
		return result;
	}
	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		ADT other = (ADT) obj;
		if (args == null) {
			if (other.args != null)
				return false;
		} else if (!args.equals(other.args))
			return false;
		if (name == null) {
			if (other.name != null)
				return false;
		} else if (!name.equals(other.name))
			return false;
		return true;
	}
	@Override
	public String toString() {
		StringBuffer result = new StringBuffer();
		result.append(name);
		result.append('(');
		boolean first = true;
		for (Type arg:args){
			if (first){
				first = false;
			}else{
				result.append(", ");
			}
			result.append(arg.toString());
		}
		result.append(')');
		return result.toString();
	}
	@Override
	public Set<VarType> vars(Set<VarType> result) {
		for (Type arg : args){
			arg.vars(result);
		}
		return result;
	}
	@Override
	public Type getDefinition(Map<String, TypeDef> typs) throws Exception{
		TypeDef def = typs.get(name);
		if (def==null) return this;
		return def.instantiate(args);
	}

}
