package name.panitz.wip.types;

import java.util.List;
import java.util.Map;
import java.util.Set;
import java.util.stream.Collectors;

import name.panitz.wip.TypeDef;

public class FunType  implements Type {
	List<Type> args;
	Type result;
	
	public FunType(List<Type> args, Type result) {
		super();
		this.args = args;
		this.result = result;
	}

	@Override
	public Type substitute(Substitution sub) {
		return new FunType(args.stream().map((x)->x.substitute(sub)).collect(Collectors.toList()), result.substitute(sub));
	}

	@Override
	public Set<VarType> vars(Set<VarType> result) {
		args.forEach((x)->x.vars(result));
		this.result.vars(result);
		return result;
	}
	
	@Override
	public String toString() {
		StringBuffer result=new StringBuffer("");
		boolean first = true;
		for (Type arg:args){
			if (first) first=false;
			else result.append(", ");
			result.append(arg);
		}
		
		result.append(") -> ");
		
		result.append(this.result);
		return result.toString();
	}

	@Override
	public 	Type getDefinition(Map<String, TypeDef> typs){
		return this;
	}
}
