package name.panitz.wip.types;

import java.util.Map;
import java.util.Set;

import name.panitz.wip.TypeDef;

public class PrimType implements Type{
	String name;

	public PrimType(String name) {
		super();
		this.name = name;
	}

	@Override
	public Type substitute(Substitution sub) {
		return this;
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((name == null) ? 0 : name.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		PrimType other = (PrimType) obj;
		if (name == null) {
			if (other.name != null)
				return false;
		} else if (!name.equals(other.name))
			return false;
		return true;
	}
	@Override
	public String toString() {
		return name;
	}

	@Override
	public Set<VarType> vars(Set<VarType> result) {
		return result;
	}

	@Override
	public Type getDefinition(Map<String, TypeDef> typs) {
		return this;
	}

}
