package name.panitz.wip.types;

import java.util.HashSet;
import java.util.Map;
import java.util.Set;

import name.panitz.wip.TypeDef;

public interface Type {
	Type substitute(Substitution sub);
	default Set<VarType> vars(){
		return vars(new HashSet<VarType>());
	}
	Set<VarType> vars(Set<VarType> result);

	default Substitution freshSub(){
		Set<VarType> vs = vars();
		Substitution sub = new Substitution();
		for (VarType v:vs){
			sub.put(v.name, VarType.newVar(TypeChecker.newName()));
		}
		return sub;
	}
	
	default Type fresh(){
		return substitute(freshSub());
	}
	Type getDefinition(Map<String, TypeDef> typs) throws Exception;
}
