package name.panitz.wip.types;

import java.util.Map;
import java.util.Set;

import name.panitz.wip.TypeDef;

public class VarType implements Type{
	String name;
	boolean fixed = true;

	static VarType newVar(String name){
		VarType result = new VarType(name);
		result.fixed = false;
		return result;
	}
	
	public VarType(String name) {
		super();
		this.name = name;
	}

	@Override
	public Type substitute(Substitution sub) {
		Type result = sub.get(name);
		return result==null?this:result;
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((name == null) ? 0 : name.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		VarType other = (VarType) obj;
		if (name == null) {
			if (other.name != null)
				return false;
		} else if (!name.equals(other.name))
			return false;
		return true;
	}
	@Override
	public String toString() {
		return name;
	}

	@Override
	public Set<VarType> vars(Set<VarType> result) {
		result.add(this);
		return result;
	}

	@Override
	public Type getDefinition(Map<String, TypeDef> typs) {
		return this;
	}

}
